<?php

class BlagajnaController extends Controller
{
    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column2';



    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function accessRules() {
        return array(
            array('allow',
                'expression' => 'Yii::app()->user->checkAccess(Yii::app()->controller->id.":".Yii::app()->controller->action->id)'),
            array('deny', 'users' =>array('*'))
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate()
    {
        $model = new Blagajna();

        $model->user_id = Yii::app()->user->id;
        $model->datum = date('d-m-Y');

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['Blagajna'])) {
            $model->attributes = $_POST['Blagajna'];
            if ($model->save())
                $this->redirect(array('view', 'id' => $model->id));
        }

        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model = $this->loadModel($id);

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['Blagajna'])) {
            $model->attributes = $_POST['Blagajna'];
            if ($model->save())
                $this->redirect(array('view', 'id' => $model->id));
        }

        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
        if (Yii::app()->request->isPostRequest) {
            // we only allow deletion via POST request
            $this->loadModel($id)->delete();



            // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax']))
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        } else
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
    }

    /**
     * Lists all models.
     */
    public function actionIndex()
    {
        $model = new Blagajna('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Blagajna']))
            $model->attributes = $_GET['Blagajna'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin()
    {
        $model = new Blagajna('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Blagajna']))
            $model->attributes = $_GET['Blagajna'];

        //ovaj deo je bitan za paginaciju
        $pageSize = Yii::app()->params['defaultPageSize'];
        if (isset($_GET['pageSize'])) {
            Yii::app()->user->setState('pageSize', (int)$_GET['pageSize']);
            $pageSize = $_GET['pageSize'];
            unset($_GET['pageSize']);
        }

        $this->render('admin', array(
            'model' => $model,
            'pageSize' => $pageSize,
        ));
    }

    /**
     * Prikaz stanja
     */
    public function actionStanje()
    {
        $model = new Blagajna();

        $this->render('stanje', array(
            'stanje' => $model->vratiStanje(),
            'lista' => $model->poslednjaNedelja(),
        ));
    }


    /**
     * Prikaz tabele promena
     */
    public function actionTabela()
    {
        $model = new Blagajna();

        $model->datum_od = date('01-m-Y');
        $model->datum_do = date('d-m-Y');

        if (isset($_GET['Blagajna'])){
            $model->attributes = $_GET['Blagajna'];
            $model->datum_od = $_GET['Blagajna']['datum_od'];
            $model->datum_do = $_GET['Blagajna']['datum_do'];
        }


        $dodavanje = Tippromene::model()->findAllByAttributes(array('ulaz_izlaz'=>1)); // ->active()
        $uzimanje = Tippromene::model()->findAllByAttributes(array('ulaz_izlaz'=>2)); // ->active()

        $korisnici = User::model()->findAll();

        $this->render('tabela', array(
            'model' => $model,
            'dodavanje' => $dodavanje,
            'uzimanje' => $uzimanje,
            'korisnici' => $korisnici,

        ));
    }


    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer the ID of the model to be loaded
     */
    public function loadModel($id)
    {
        $model = Blagajna::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param CModel the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'blagajna-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function actionDodaj()
    {
        Yii::app()->clientScript->scriptMap = array(
            'jquery.js' => false,
            'jquery.ba-bbq.js' => false,
            'jquery.coolfieldset.js' => false,
            'jquery-ui.min.js' => false
        );

        if (Yii::app()->getRequest()->getIsAjaxRequest()) {
             $this->renderPartial('_opcije',
                 array('tip'=>1), false, true);
        } else throw new CHttpException(400, Yii::t('translation', 'Greska!'));


    }

    public function actionUzmi()
    {
        Yii::app()->clientScript->scriptMap = array(
            'jquery.js' => false,
            'jquery.ba-bbq.js' => false,
            'jquery.coolfieldset.js' => false,
            'jquery-ui.min.js' => false
        );


        if (Yii::app()->getRequest()->getIsAjaxRequest()) {
            $this->renderPartial('_opcije',
                array('tip'=>2), false, true);
        } else throw new CHttpException(400, Yii::t('translation', 'Greska!'));


    }

    public function actionOpcija($id)
    {
        Yii::app()->clientScript->scriptMap = array(
            'jquery.js' => false,
            'jquery.ba-bbq.js' => false,
            'jquery.coolfieldset.js' => false,
            'jquery-ui.min.js' => false
        );

        $tip = Tippromene::model()->findByPk($id);
        $opcija = "Dodavanja";
        if($tip->ulaz_izlaz == "1"){
            $opcija = "Dodavanja";
        } else {
            $opcija = "Uzimanja";
        }

        if (Yii::app()->getRequest()->getIsAjaxRequest()) {
            $this->renderPartial('_info',
                array(
                    'opcija'=>$opcija,
                    'tip'=>$tip->naziv
                ), false, true);
        } else throw new CHttpException(400, Yii::t('translation', 'Greska!'));


    }
}
